Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision d09ff7ad9c8d572bf86f780836ed477e92efd995)
+++ src/Makefile.am	(revision cee0b57afea6660531722346890ed484e9ea8dd4)
@@ -1,4 +1,4 @@
-SOURCE = atom.cpp bond.cpp boundary.cpp config.cpp element.cpp ellipsoid.cpp helpers.cpp leastsquaremin.cpp linkedcell.cpp moleculelist.cpp molecules.cpp parser.cpp periodentafel.cpp tesselation.cpp tesselationhelpers.cpp vector.cpp verbose.cpp
-HEADER = atom.hpp bond.hpp boundary.hpp config.hpp defs.hpp element.hpp ellipsoid.hpp helpers.hpp leastsquaremin.hpp linkedcell.hpp memoryallocator.hpp memoryusageobserver.cpp memoryusageobserver.hpp molecules.hpp parser.hpp periodentafel.hpp stackclass.hpp tesselation.hpp tesselationhelpers.hpp vector.hpp verbose.hpp
+SOURCE = atom.cpp bond.cpp boundary.cpp config.cpp element.cpp ellipsoid.cpp helpers.cpp leastsquaremin.cpp linkedcell.cpp moleculelist.cpp molecule.cpp molecule_dynamics.cpp molecule_fragmentation.cpp molecule_geometry.cpp molecule_graph.cpp molecule_pointcloud.cpp parser.cpp periodentafel.cpp tesselation.cpp tesselationhelpers.cpp vector.cpp verbose.cpp
+HEADER = atom.hpp bond.hpp boundary.hpp config.hpp defs.hpp element.hpp ellipsoid.hpp helpers.hpp leastsquaremin.hpp linkedcell.hpp memoryallocator.hpp memoryusageobserver.cpp memoryusageobserver.hpp molecule.hpp parser.hpp periodentafel.hpp stackclass.hpp tesselation.hpp tesselationhelpers.hpp vector.hpp verbose.hpp
 
 noinst_PROGRAMS =  ActOnAllTest VectorUnitTest MemoryAllocatorUnitTest MemoryUsageObserverUnitTest TesselationUnitTest
Index: src/boundary.hpp
===================================================================
--- src/boundary.hpp	(revision d09ff7ad9c8d572bf86f780836ed477e92efd995)
+++ src/boundary.hpp	(revision cee0b57afea6660531722346890ed484e9ea8dd4)
@@ -12,5 +12,5 @@
 #include "config.hpp"
 #include "linkedcell.hpp"
-#include "molecules.hpp"
+#include "molecule.hpp"
 #include "tesselation.hpp"
 
Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision d09ff7ad9c8d572bf86f780836ed477e92efd995)
+++ src/builder.cpp	(revision cee0b57afea6660531722346890ed484e9ea8dd4)
@@ -54,5 +54,5 @@
 #include "helpers.hpp"
 #include "memoryusageobserverunittest.hpp"
-#include "molecules.hpp"
+#include "molecule.hpp"
 /********************************************* Subsubmenu routine ************************************/
 
Index: src/config.hpp
===================================================================
--- src/config.hpp	(revision d09ff7ad9c8d572bf86f780836ed477e92efd995)
+++ src/config.hpp	(revision cee0b57afea6660531722346890ed484e9ea8dd4)
@@ -16,5 +16,5 @@
 #endif
 
-#include "molecules.hpp"
+#include "molecule.hpp"
 #include "periodentafel.hpp"
 
Index: src/graph.hpp
===================================================================
--- src/graph.hpp	(revision d09ff7ad9c8d572bf86f780836ed477e92efd995)
+++ src/graph.hpp	(revision cee0b57afea6660531722346890ed484e9ea8dd4)
@@ -17,5 +17,5 @@
 #include <multimap>
 
-#include "molecules.hpp"
+#include "molecule.hpp"
 
 class Graph;
Index: src/linkedcell.cpp
===================================================================
--- src/linkedcell.cpp	(revision d09ff7ad9c8d572bf86f780836ed477e92efd995)
+++ src/linkedcell.cpp	(revision cee0b57afea6660531722346890ed484e9ea8dd4)
@@ -7,5 +7,5 @@
 
 #include "linkedcell.hpp"
-#include "molecules.hpp"
+#include "molecule.hpp"
 #include "tesselation.hpp"
 
Index: src/molecule.cpp
===================================================================
--- src/molecule.cpp	(revision d09ff7ad9c8d572bf86f780836ed477e92efd995)
+++ src/molecule.cpp	(revision cee0b57afea6660531722346890ed484e9ea8dd4)
@@ -7,5 +7,5 @@
 #include "config.hpp"
 #include "memoryallocator.hpp"
-#include "molecules.hpp"
+#include "molecule.hpp"
 
 /************************************* Functions for class molecule *********************************/
@@ -68,81 +68,4 @@
 };
 
-
-/** Determine center of all atoms.
- * \param *out output stream for debugging
- * \return pointer to allocated with central coordinates
- */
-Vector *molecule::GetCenter(ofstream *out)
-{
-  Vector *center = DetermineCenterOfAll(out);
-  return center;
-};
-
-/** Return current atom in the list.
- * \return pointer to atom or NULL if none present
- */
-TesselPoint *molecule::GetPoint()
-{
-  if ((InternalPointer != start) && (InternalPointer != end))
-    return InternalPointer;
-  else
-    return NULL;
-};
-
-/** Return pointer to one after last atom in the list.
- * \return pointer to end marker
- */
-TesselPoint *molecule::GetTerminalPoint()
-{
-  return end;
-};
-
-/** Go to next atom.
- * Stops at last one.
- */
-void molecule::GoToNext()
-{
-  if (InternalPointer != end)
-    InternalPointer = InternalPointer->next;
-};
-
-/** Go to previous atom.
- * Stops at first one.
- */
-void molecule::GoToPrevious()
-{
-  if (InternalPointer->previous != start)
-    InternalPointer = InternalPointer->previous;
-};
-
-/** Goes to first atom.
- */
-void molecule::GoToFirst()
-{
-  InternalPointer = start->next;
-};
-
-/** Goes to last atom.
- */
-void molecule::GoToLast()
-{
-  InternalPointer = end->previous;
-};
-
-/** Checks whether we have any atoms in molecule.
- * \return true - no atoms, false - not empty
- */
-bool molecule::IsEmpty()
-{
-  return (start->next == end);
-};
-
-/** Checks whether we are at the last atom
- * \return true - current atom is last one, false - is not last one
- */
-bool molecule::IsEnd()
-{
-  return (InternalPointer == end);
-};
 
 /** Adds given atom \a *pointer from molecule list.
@@ -575,17 +498,9 @@
   while(Binder->next != last) {
     Binder = Binder->next;
+
     // get the pendant atoms of current bond in the copy molecule
-    LeftAtom = copy->start;
-    while (LeftAtom->next != copy->end) {
-      LeftAtom = LeftAtom->next;
-      if (LeftAtom->father == Binder->leftatom)
-        break;
-    }
-    RightAtom = copy->start;
-    while (RightAtom->next != copy->end) {
-      RightAtom = RightAtom->next;
-      if (RightAtom->father == Binder->rightatom)
-        break;
-    }
+    copy->ActOnAllAtoms( &atom::EqualsFather, Binder->leftatom, &LeftAtom );
+    copy->ActOnAllAtoms( &atom::EqualsFather, Binder->rightatom, &RightAtom );
+
     NewBond = copy->AddBond(LeftAtom, RightAtom, Binder->BondDegree);
     NewBond->Cyclic = Binder->Cyclic;
@@ -595,12 +510,6 @@
   }
   // correct fathers
-  Walker = copy->start;
-  while(Walker->next != copy->end) {
-    Walker = Walker->next;
-    if (Walker->father->father == Walker->father)   // same atom in copy's father points to itself
-      Walker->father = Walker;  // set father to itself (copy of a whole molecule)
-    else
-     Walker->father = Walker->father->father;  // set father to original's father
-  }
+  ActOnAllAtoms( &atom::CorrectFather );
+
   // copy values
   copy->CountAtoms((ofstream *)&cout);
@@ -644,5 +553,5 @@
  * \return pointer to bond or NULL on failure
  */
-bond * molecule::AddBond(atom *atom1, atom *atom2, int degree=1)
+bond * molecule::AddBond(atom *atom1, atom *atom2, int degree)
 {
   bond *Binder = NULL;
